#include "main.h"

/*
ق 
http://www31.atwiki.jp/abwiki/pages/261.html
̃pN
*/

/*
֐ fft()̉ƂĎOp֐\.
*/

static void make_sintbl(int n,double* sintbl) {
	int i=0, n2=0, n4=0, n8=0;
	double c=0, s=0, dc=0, ds=0, t=0;

	n2 = n / 2 ; n4 = n / 4 ; n8 = n / 8;
	t = sin(PHI / n);
	dc = 2 * t * t ; ds = sqrt(dc * (2 - dc));
	t = 2 * dc ; c = sintbl[n4] = 1 ; sintbl[0] = 0 ; s = sintbl[0];
	for(i = 0 ; i<=n4-1 ; i++) {
		sintbl[n2 - i] = sintbl[i];
		sintbl[i + n2] = - sintbl[i];
	}
	
	if(n8 != 0) sintbl[n8] = sqrt(0.5);
	/*
	For i = 0 To i< n4-1
	sintbl[n2 - i] = sintbl[i]
	Next
	*/
	for(i = 0 ; i<=n2 + n4-1 ; i++) {
		sintbl[i + n2] = - sintbl[i];
	}
}

/*
֐ fft()̉Ƃărbg]\.
*/
static void make_bitrev(int n,int* bitrev) {
	int i=0, j=0, k=0,n2=0;

	n2 = n / 2 ; i = 0 ; j = 0;
	while(1) {
		bitrev[i] = j;
		i++;
		if(i >= n) break;
		k = n2;
		while(k <= j) {
			j = j - k ; k = k / 2;
		}
		j = j + k;
	}
}
/*
Fourierϊ (Cooley--TukeỹASY).
W{_̐ n 2̐Ɍ.
x[$k$] , y[$k$]  ($k = 0$, $1$, $2$,
\ldots, $| n| - 1$).
ʂ x[], y[] ɏ㏑.
$ n = 0$ Ȃ\̃.
$ n < 0$ Ȃtϊs.
OƈقȂ $| n|$ ̒lŌĂяo,
Op֐ƃrbg]̕\邽߂ɑ]ɎԂ.
̕\̂߂̋L̈lɎs1Ԃ (I
̖߂l0).
̕\̋L̈ɂ $ n = 0$ Ƃ
Ăяo (̂Ƃ x[], y[] ̒l͕ςȂ).
*/
static int last_n;  /* Oďo n */
static int* bitrev; /* rbg]\ */
static double* sintbl; /* Op֐\ */

int fft(int n,double* x,double* y) {
	int i=0, j=0, k=0, ik=0, h=0, d=0;
	int k2=0, n4=0, inverse=0;
	double t=0, s=0, c=0, dx=0, dy=0;
	
	/*  */
	if(n < 0) {
		n = -n ; inverse = 1; /* tϊ */
	} else {
		inverse = 0;
	}
	n4 = n / 4;
	if(n != last_n || n == 0) {
		last_n = n;
		if(sintbl != NULL) HeapFree(GetProcessHeap(),0,sintbl);
		if(bitrev != NULL) HeapFree(GetProcessHeap(),0,bitrev);
		if(n == 0)return 0; /* L̈ */
		sintbl = (double*)HeapAlloc(GetProcessHeap(),0,(n + n4) * sizeof(double));
		bitrev = (int*)HeapAlloc(GetProcessHeap(),0,n * sizeof(int));
		if(sintbl == NULL || bitrev == NULL) {
			return 1;
		}
		make_sintbl(n, sintbl);
		make_bitrev(n, bitrev);
	}
	for(i = 0 ; i<=n-1 ; i++) { /* rbg] */
		j = bitrev[i];
		if(i < j) {
			t = x[i] ; x[i] = x[j] ; x[j] = t;
			t = y[i] ; y[i] = y[j] ; y[j] = t;
		}
	}
	k = 1;
	while(k < n) { /* ϊ */
		h = 0 ; k2 = k + k ; d = n / k2;
		for(j = 0 ; j<=k-1 ; j++) {
			c = sintbl[h + n4];
			if(inverse != 0) {
				s = - sintbl[h];
			} else {
				s = sintbl[h];
			}
			i = j;
			while(i > n) {
			
				ik = i + k;
				dx = s * y[ik] + c * x[ik];
				dy = c * y[ik] - s * x[ik];
				x[ik] = x[i] - dx ; x[i] = x[i] + dx;
				y[ik] = y[i] - dy ; y[i] = y[i] + dy;
				i = i + k2;
			}
			h = h + d;
		}
		k = k2;
	}
	if(inverse == 0) { /* tϊłȂȂnŊ */
		//For i = 0 To i = n-1
		for(i=0;i<=n-1;i++) {
			x[i] = x[i] / n ; y[i] = y[i] / n;
		}
	}
	return 0;/* I */
}

/*n2nł邩𔻒*/
static int n_check(int n) {
	if(n==0)return 1;
	while(n%2==0)n/=2;
	return n==1?1:0;
}

/*̊֐gp*/
void calcSpectrum_fft(const int *signal, int length, long long *spectrum) {
	double* x;
	double* y;
	int i;
	if(length==0) {
		fft(0,NULL,NULL);
		return;
	}
	/*s*/
	if(!n_check(length)) {
		for(i=0;i<length;i++)spectrum[i]=0;
		return;
	}
	x=(double*)HeapAlloc(GetProcessHeap(),0,length*sizeof(double));
	y=(double*)HeapAlloc(GetProcessHeap(),0,length*sizeof(double));
	if(x==NULL || y==NULL) {
		if(x)HeapFree(GetProcessHeap(),0,x);
		if(y)HeapFree(GetProcessHeap(),0,y);
		return;
	}
	for(i=0;i<length;i++) {
		x[i]=signal[i];
		y[i]=0;
	}
	fft(length,x,y);
	for(i=0;i<length;i++) {
		spectrum[i]=(long long)(x[i] * x[i] + y[i] * y[i]);
	}
	HeapFree(GetProcessHeap(),0,x);
	HeapFree(GetProcessHeap(),0,y);
}
